merge-one-file: make sure we create the merged file.
[git/git.git] / git-merge-one-file.sh
1 #!/bin/sh
2 #
3 # Copyright (c) Linus Torvalds, 2005
4 #
5 # This is the git per-file merge script, called with
6 #
7 # $1 - original file SHA1 (or empty)
8 # $2 - file in branch1 SHA1 (or empty)
9 # $3 - file in branch2 SHA1 (or empty)
10 # $4 - pathname in repository
11 # $5 - orignal file mode (or empty)
12 # $6 - file in branch1 mode (or empty)
13 # $7 - file in branch2 mode (or empty)
14 #
15 # Handle some trivial cases.. The _really_ trivial cases have
16 # been handled already by git-read-tree, but that one doesn't
17 # do any merges that might change the tree layout.
18
19 case "${1:-.}${2:-.}${3:-.}" in
20 #
21 # Deleted in both or deleted in one and unchanged in the other
22 #
23 "$1.." | "$1.$1" | "$1$1.")
24 if [ "$2" ]; then
25 echo "Removing $4"
26 fi
27 if test -f "$4"; then
28 rm -f -- "$4" &&
29 rmdir -p "$(expr "$4" : '\(.*\)/')" 2>/dev/null || :
30 fi &&
31 exec git-update-index --remove -- "$4"
32 ;;
33
34 #
35 # Added in one.
36 #
37 ".$2." | "..$3" )
38 echo "Adding $4"
39 git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
40 exec git-checkout-index -u -f -- "$4"
41 ;;
42
43 #
44 # Added in both, identically (check for same permissions).
45 #
46 ".$3$2")
47 if [ "$6" != "$7" ]; then
48 echo "ERROR: File $4 added identically in both branches,"
49 echo "ERROR: but permissions conflict $6->$7."
50 exit 1
51 fi
52 echo "Adding $4"
53 git-update-index --add --cacheinfo "$6" "$2" "$4" &&
54 exec git-checkout-index -u -f -- "$4"
55 ;;
56
57 #
58 # Modified in both, but differently.
59 #
60 "$1$2$3" | ".$2$3")
61 src2=`git-unpack-file $3`
62 case "$1" in
63 '')
64 echo "Added $4 in both, but differently."
65 # This extracts OUR file in $orig, and uses git-apply to
66 # remove lines that are unique to ours.
67 orig=`git-unpack-file $2`
68 sz0=`wc -c <"$orig"`
69 diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add
70 sz1=`wc -c <"$orig"`
71
72 # If we do not have enough common material, it is not
73 # worth trying two-file merge using common subsections.
74 expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
75 ;;
76 *)
77 echo "Auto-merging $4."
78 orig=`git-unpack-file $1`
79 ;;
80 esac
81
82 # Create the working tree file, with the correct permission bits.
83 # we can not rely on the fact that our tree has the path, because
84 # we allow the merge to be done in an unchecked-out working tree.
85 rm -f "$4" &&
86 git-cat-file blob "$2" >"$4" &&
87 case "$6" in *7??) chmod +x "$4" ;; esac &&
88 merge "$4" "$orig" "$src2"
89 ret=$?
90 rm -f -- "$orig" "$src2"
91
92 if [ "$6" != "$7" ]; then
93 echo "ERROR: Permissions conflict: $5->$6,$7."
94 ret=1
95 fi
96 if [ "$1" = '' ]; then
97 ret=1
98 fi
99
100 if [ $ret -ne 0 ]; then
101 echo "ERROR: Merge conflict in $4."
102 exit 1
103 fi
104 exec git-update-index -- "$4"
105 ;;
106
107 *)
108 echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
109 ;;
110 esac
111 exit 1